# Fourth-Order Runge-Kutta
# dx/dt= -x**3+sin(t)

import numpy as np
import matplotlib.pyplot as plt

def f(x, t):
  return -x**3+np.sin(t)

t=np.linspace(0, 10, 1000)

x=np.zeros(len(t), float)
x[0]=0
tau=t[1]-t[0]

for i in range(len(t)-1):   # 4-th order RKM
  c_1=tau*f(x[i], t[i])
  c_2=tau*f(x[i]+c_1/2, t[i]+tau/2)
  c_3=tau*f(x[i]+c_2/2, t[i]+tau/2)
  c_4=tau*f(x[i]+c_3, t[i]+tau)
  x[i+1]=x[i]+(c_1+2*c_2+2*c_3+c_4)/6

plt.plot(t, x)
plt.show()
